
#include "Arduino.h"
#define BUF_SIZE 256
uint8_t buf[BUF_SIZE];
uint8_t pwmPin = 5; // OC3A (timer 3, Output compare A), PE3 (port E sortie 3)
uint8_t clockBits;
uint16_t top_0, ocra_0;
uint16_t top_1, ocra_1;
volatile uint8_t buf_index;
volatile uint8_t bit_index;
              
void fsk_pulse_train(uint32_t period, int32_t nombre, float rapport) { // periode en microsecondes, nombre d'impulsions
  cli(); // on désactive les interruptions
  TCCR3A = 0;
  TCCR3A |= (1 << COM3A1) | (1 << COM3A0);
  TCCR3B = 1 << WGM13; // phase and frequency correct pwm mode, top = ICR3
  clockBits = 1 << CS10; 
  top_0 = (F_CPU/1000000*period/2); 
  ocra_0 = top_0 * (1.0-rapport);
  top_1 = top_0 << 1;
  ocra_1 = ocra_0 << 1;
  ICR3 = top_0;
  OCR3A = ocra_0;

  bit_index = 0;
  buf_index = 0;

  TCCR1A = 0;
  TCCR1A |= (1 << COM1A1);
  TCCR1B = 1 << WGM13;
  ICR1 = top_0*nombre ;
  OCR1A = ocra_0*nombre;
  TIMSK1 = 1 << OCIE3A; // output compare A match interrupt
  sei(); // activation des interruptions
  
  TCCR3B |= clockBits; // déclenchement des Timers
  TCCR1B |= clockBits;

}
               
ISR(TIMER1_COMPA_vect) {
    uint8_t b;
    b = buf[buf_index] & (1 << bit_index);
    bit_index++;
    if (bit_index==8) {
        bit_index = 0;
        buf_index++;
      }
    if (b==0) {
        ICR3 = top_1;
        OCR3A = ocra_1;
        TCNT3 = 0;
    }
    else {
        ICR3 = top_0;
        OCR3A = ocra_0;
        TCNT3 = 0;
     }
}
                
void setup() {
  int i;
  DDRE |= 1 << PORTE3; // borne 5 en sortie
  DDRB |= 1 << PORTB5; // borne 11 en sortie
  for (i=0; i<BUF_SIZE; i++) {
        buf[i] = 0xAA; 
    }
  fsk_pulse_train(10,30,0.5);
}
                
void loop() {

}
                